Index: ChangeLog
===================================================================
--- ChangeLog	(revision 4292)
+++ ChangeLog	(revision 4296)
@@ -5,4 +5,5 @@
 	* fixed a problem with PASSFH on some systems
 	* Added LTM support to libroar and roard (roard only supports RMS)
+	* Added a lot const keywords
 
 v. 0.3 - Sun Aug 22 2010 26:14 CEST
Index: include/libroar/auth.h
===================================================================
--- include/libroar/auth.h	(revision 3915)
+++ include/libroar/auth.h	(revision 4296)
@@ -52,6 +52,6 @@
 int roar_auth   (struct roar_connection * con);
 
-int    roar_str2autht(char * str);
-char * roar_autht2str(int auth);
+int    roar_str2autht(const char * str);
+const char * roar_autht2str(const int auth);
 
 #endif
Index: include/libroar/meta.h
===================================================================
--- include/libroar/meta.h	(revision 3517)
+++ include/libroar/meta.h	(revision 4296)
@@ -46,11 +46,11 @@
 int roar_meta_free (struct roar_meta * meta);
 
-char * roar_meta_strtype(int type);
-int    roar_meta_inttype(char * type);
+char * roar_meta_strtype(const int type);
+int    roar_meta_inttype(const char * type);
 
-char * roar_meta_strgenre(int genre);
-int    roar_meta_intgenre(char * genre);
+const char * roar_meta_strgenre(const int genre);
+int    roar_meta_intgenre(const char * genre);
 
-int    roar_meta_parse_audioinfo(struct roar_audio_info * info, char * str);
+int    roar_meta_parse_audioinfo(struct roar_audio_info * info, const char * str);
 
 #endif
Index: include/libroar/stream.h
===================================================================
--- include/libroar/stream.h	(revision 4097)
+++ include/libroar/stream.h	(revision 4296)
@@ -39,6 +39,6 @@
 #include "roaraudio.h"
 
-char * roar_dir2str (int dir);
-int    roar_str2dir (char * name);
+const char * roar_dir2str (const int dir);
+int    roar_str2dir (const char * name);
 
 struct roar_stream_info {
@@ -98,11 +98,11 @@
 int roar_stream_m2s     (struct roar_stream * s, struct roar_message * m);
 
-int    roar_str2codec (char * codec);
-char * roar_codec2str (int    codec);
+int    roar_str2codec (const char * codec);
+const char * roar_codec2str (const int    codec);
 
-char * roar_streamstate2str(int streamstate);
+const char * roar_streamstate2str(int streamstate);
 
-int    roar_str2role  (char * role);
-char * roar_role2str  (int    role);
+int    roar_str2role  (const char * role);
+const char * roar_role2str  (const int    role);
 
 ssize_t roar_info2samplesize (struct roar_audio_info * info);
Index: libroar/auth.c
===================================================================
--- libroar/auth.c	(revision 3740)
+++ libroar/auth.c	(revision 4296)
@@ -198,5 +198,5 @@
 static struct {
  int    type;
- char * name;
+ const char * name;
 } _g_authts[] = {
 // grep ^'#define ROAR_AUTH_T_' auth.h | while read d t d; do n=$(cut -d_ -f4 <<<$t | tr A-Z a-z); printf ' {%-28s %-10s},\n' $t, \"$n\"; done
@@ -216,5 +216,5 @@
 };
 
-int    roar_str2autht(char * str) {
+int    roar_str2autht(const char * str) {
  int i;
 
@@ -226,5 +226,5 @@
 }
 
-char * roar_autht2str(int auth) {
+const char * roar_autht2str(const int auth) {
  int i;
 
Index: libroar/meta.c
===================================================================
--- libroar/meta.c	(revision 3875)
+++ libroar/meta.c	(revision 4296)
@@ -42,7 +42,7 @@
 */
 
-struct {
+static struct {
  int    id;
- char * name;
+ const char * name;
 } _libroar_meta_typelist[] = {
  {ROAR_META_TYPE_NONE,               "NONE"           },
@@ -92,7 +92,7 @@
 
 
-struct {
+static struct {
  int    id;
- char * name;
+ const char * name;
 } _libroar_meta_genrelist[] = {
 {ROAR_META_GENRE_RDS_EU_NONE,             "rds_eu_none"},
@@ -396,5 +396,6 @@
 };
 
-char * roar_meta_strtype(int type) {
+// TODO: Why do we return a non-const buffer here?
+char * roar_meta_strtype(const int type) {
  int i;
  static char name[ROAR_META_MAX_NAMELEN];
@@ -409,5 +410,5 @@
 }
 
-int    roar_meta_inttype(char * type) {
+int    roar_meta_inttype(const char * type) {
  int i;
 
@@ -545,5 +546,5 @@
 
 // genere:
-char * roar_meta_strgenre(int genre) {
+const char * roar_meta_strgenre(const int genre) {
  int i;
 
@@ -556,5 +557,5 @@
 }
 
-int    roar_meta_intgenre(char * genre) {
+int    roar_meta_intgenre(const char * genre) {
  int i;
 
@@ -567,5 +568,5 @@
 }
 
-int    roar_meta_parse_audioinfo(struct roar_audio_info * info, char * str) {
+int    roar_meta_parse_audioinfo(struct roar_audio_info * info, const char * str) {
  char * lc;
  char * cur, * next;
Index: libroar/stream.c
===================================================================
--- libroar/stream.c	(revision 4002)
+++ libroar/stream.c	(revision 4296)
@@ -738,7 +738,7 @@
 */
 
-struct {
+static struct {
  int    dir;
- char * name;
+ const char * name;
 } _libroar_dir[] = {
  {ROAR_DIR_PLAY,        "play"       },
@@ -765,5 +765,5 @@
 };
 
-char * roar_dir2str (int dir) {
+const char * roar_dir2str (const int dir) {
  int i;
 
@@ -775,5 +775,5 @@
 }
 
-int roar_str2dir (char * name) {
+int roar_str2dir (const char * name) {
  int i;
 
@@ -793,7 +793,7 @@
 */
 
-struct {
+static struct {
  int    codec;
- char * name;
+ const char * name;
 } _libroar_codec[] = {
  // PCM:
@@ -883,5 +883,5 @@
 };
 
-int roar_str2codec(char * codec) {
+int roar_str2codec(const char * codec) {
  int i;
  int guess;
@@ -904,5 +904,5 @@
 
 
-char * roar_codec2str (int codec) {
+const char * roar_codec2str (const int codec) {
  int i;
 
@@ -914,5 +914,5 @@
 }
 
-char * roar_streamstate2str(int streamstate) {
+const char * roar_streamstate2str(int streamstate) {
  switch (streamstate) {
   case ROAR_STREAMSTATE_UNUSED:  return "unused";  break;
@@ -926,7 +926,7 @@
 }
 
-struct {
+static struct {
  int    role;
- char * name;
+ const char * name;
 } _libroar_role[] = {
  {ROAR_ROLE_UNKNOWN,          "unknown"         },
@@ -948,5 +948,5 @@
 };
 
-int    roar_str2role  (char * role) {
+int    roar_str2role  (const char * role) {
  int i;
 
@@ -958,5 +958,5 @@
 }
 
-char * roar_role2str  (int    role) {
+const char * roar_role2str  (const int    role) {
  int i;
 